package com.eactive.eai.batch.job.jobItem.ftbat;

import java.io.ByteArrayOutputStream;
import java.io.File;

import com.eactive.eai.batch.job.jobConstant.TelegramKeys;
import com.eactive.eai.batch.job.jobItem.DefaultTelegram;
import com.eactive.eai.batch.job.jobItem.TelegramService;

import com.eactive.eai.batch.common.LogUtil;
import com.eactive.eai.batch.common.StringUtil;
import com.eactive.eai.common.exception.ExceptionUtil;

public class SEND_FTBAT_0240 extends DefaultTelegram implements TelegramService
{


    /**
     * 생성자
     */
    public SEND_FTBAT_0240() {
    }

    /**
     * 전문조립
     */
    public boolean doExecute() {
        try {

            byte[] som = new byte[1];
            byte[] eom = new byte[1];
            som[0] = 0x02;
            eom[0] = 0x03;

            //메시지 시작 문자
            al_Field.set(0, som);

            //메시지 타입
            compileField(1, this.getFldTelegramType(), this.al_FieldProps[1]);

            //파일사이즈
            compileField(2, "" + batchDoc.getBatchMsg().getBody().getCurFileSize(), this.al_FieldProps[2]);

            //오류코드
            compileField(3, getSendResponseCode(), this.al_FieldProps[3]);

            //오류메시지
            compileField(4, batchDoc.getBatchMsg().getBody().getErrorMsg(), this.al_FieldProps[4]);

            //filler
            compileField(5, "", this.al_FieldProps[5]);

            //메시지 종료 문자
            al_Field.set(6, eom);

            //<< 전문 완성
            return true;

        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI001";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return false;
        }

    }

    /**
     * 실제 송신할 전문의 총길이를 리턴해준다.
     */
    public int getSendLength()
    {
        try {
            return 1024;  //실 DATA BYTE수
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI013";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return -1;
        }
    }

    public boolean doPreExecute() {
        try {
            if (!super.doPreExecute()) return false;
            try {
				//Thread.sleep(sleepTime); 
			} catch (Exception e) {
				logger.error( e.getMessage(), e);
			}
            return true;
        } catch (Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI003";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( ex.getMessage(), ex);
            return false;
        }
    }

    public boolean doPostExecute() {
        if (!super.doPostExecute()) return false;
        try {
            //DB로그에 남길 전문 헤더 설정
            ByteArrayOutputStream baout = new ByteArrayOutputStream();
            for (int i=1; i<2; i++) {
                baout.write((byte[])this.al_Field.get(i));
            }
            batchDoc.getBatchMsg().setTelegramHeader(new String(baout.toByteArray()));

            //DB로그에 남길 전문 바디 설정
            baout = new ByteArrayOutputStream();
            for (int i=2; i< al_Field.size()-1; i++) {
                baout.write((byte[])this.al_Field.get(i));
            }
            batchDoc.getBatchMsg().setTelegramBody(new String(baout.toByteArray()));


            String fileDir = batchDoc.getBatchMsg().getHeader().getFilePath();
            String fileNm  = batchDoc.getBatchMsg().getHeader().getFileName();
            if (fileDir.charAt(fileDir.length()-1) != File.separatorChar) {
                fileDir = fileDir + File.separator;
            }
            String fileName = fileDir + fileNm;

            File rcvRealFile = new File( fileName );
            File rcvArchFile = new File( StringUtil.realToArchDir(fileName) );
            File rcvRootFile = new File( StringUtil.realToRootDir(fileName) );

            if ((fileNm != null) && (!fileNm.trim().equals(""))&& (rcvRealFile.exists()) && getSendResponseCode().equals("0000")) {

                //DB로그에 남길 파일 헤더,트레일러 내용 설정
                super.setFileHeaderAndTrailer(rcvRealFile);

                //DB로그에 남길 변경 파일명 설정 (파일명 변경 안함)
                batchDoc.getBatchMsg().getHeader().setRenamedFileName(fileName);
                //수신 Real 디렉토리 -> Arch 디렉토리로 파일 이동 (파일명 변경 안한고 동일 파일명 존재시 Overwrite)
                logger.info("{} >>>>> 수신 파일을 수신 Real 디렉토리 -> 수신 Arch 디렉토리로 이동.....", logHeader);
                boolean isSuccessMoveFile = rcvRealFile.renameTo(rcvArchFile);
                if (!isSuccessMoveFile) {
                    String errMsg = ExceptionUtil.getErrorCode("BECEAIFJI030", new String[] {rcvRealFile.getAbsolutePath(), rcvArchFile.getAbsolutePath()});
                    batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);    //수신 파일을 수신 Real 디렉토리에서 수신 Arch 디렉로 이동시 오류가 발생하였습니다. [Real Path: {1}] [Arch Path: {2}]
                    super.setResolveResponseCode(TelegramKeys.RPS_HDB_RET_CODE_OTHER_ERROR);
                    //수신 파일 End DB로그
                    LogUtil.setLogFileEnd(batchDoc);
                    return true;  //다음단계 수행시 응답코드를 기준으로 에러전문을 송신하기위해 true 설정함
                }

                logger.info("{} >>>>> 수신 파일과 동일 파일명의 0 Byte 파일을 Root 디렉토리에 생성......(HOST에 자동 송신하도록 수신 File Event 발생)", logHeader);
                try {
                    isSuccessMoveFile = rcvRootFile.createNewFile();
                } catch (Exception e) { } // 실패인 경우 무시하고 로깅만 하도록....

                if (!isSuccessMoveFile) {
                    String errMsg = ExceptionUtil.getErrorCode("BECEAIFJI031", new String[] {rcvRootFile.getAbsolutePath()});
                    batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);    //수신 Root 디렉토리에 0 Byte 파일을 생성할 수 없습니다. [Path: {1}]
                }

                //수신 파일 End DB로그
                LogUtil.setLogFileEnd(batchDoc);
           }

            return true;

        } catch(Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI002";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( ex.getMessage(), ex);
            return false;
        }
    }



    //---------------- 특정 필드값을 구하는 부분
    // 전문종별코드 필드값 리턴
    public String getTelegramType()
    {
        return super.getFieldValueString(1);
    }
//    // 거래구분코드 필드값 리턴
//    public String getTrClass()
//    {
//        return super.getFieldValueString(2);
//    }
    //응답코드 필드값 리턴
    public String getResCode()
    {
        return super.getFieldValueString(5);
    }
//    //업무관리코드 필드값 리턴
//    public String getOpCode()
//    {
//        return super.getFieldValueString(2);
//    }
}